//go:build !disable_pgv
// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: envoy/config/trace/v3/opentelemetry.proto

package tracev3

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"sort"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
	_ = sort.Sort
)

// Validate checks the field values on OpenTelemetryConfig with the rules
// defined in the proto definition for this message. If any rules are
// violated, the first error encountered is returned, or nil if there are no violations.
func (m *OpenTelemetryConfig) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on OpenTelemetryConfig with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// OpenTelemetryConfigMultiError, or nil if none found.
func (m *OpenTelemetryConfig) ValidateAll() error {
	return m.validate(true)
}

func (m *OpenTelemetryConfig) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if all {
		switch v := interface{}(m.GetGrpcService()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, OpenTelemetryConfigValidationError{
					field:  "GrpcService",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, OpenTelemetryConfigValidationError{
					field:  "GrpcService",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetGrpcService()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return OpenTelemetryConfigValidationError{
				field:  "GrpcService",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if all {
		switch v := interface{}(m.GetHttpService()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, OpenTelemetryConfigValidationError{
					field:  "HttpService",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, OpenTelemetryConfigValidationError{
					field:  "HttpService",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetHttpService()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return OpenTelemetryConfigValidationError{
				field:  "HttpService",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	// no validation rules for ServiceName

	for idx, item := range m.GetResourceDetectors() {
		_, _ = idx, item

		if all {
			switch v := interface{}(item).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, OpenTelemetryConfigValidationError{
						field:  fmt.Sprintf("ResourceDetectors[%v]", idx),
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, OpenTelemetryConfigValidationError{
						field:  fmt.Sprintf("ResourceDetectors[%v]", idx),
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(item).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return OpenTelemetryConfigValidationError{
					field:  fmt.Sprintf("ResourceDetectors[%v]", idx),
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	}

	if all {
		switch v := interface{}(m.GetSampler()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, OpenTelemetryConfigValidationError{
					field:  "Sampler",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, OpenTelemetryConfigValidationError{
					field:  "Sampler",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetSampler()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return OpenTelemetryConfigValidationError{
				field:  "Sampler",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if len(errors) > 0 {
		return OpenTelemetryConfigMultiError(errors)
	}

	return nil
}

// OpenTelemetryConfigMultiError is an error wrapping multiple validation
// errors returned by OpenTelemetryConfig.ValidateAll() if the designated
// constraints aren't met.
type OpenTelemetryConfigMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m OpenTelemetryConfigMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m OpenTelemetryConfigMultiError) AllErrors() []error { return m }

// OpenTelemetryConfigValidationError is the validation error returned by
// OpenTelemetryConfig.Validate if the designated constraints aren't met.
type OpenTelemetryConfigValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e OpenTelemetryConfigValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e OpenTelemetryConfigValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e OpenTelemetryConfigValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e OpenTelemetryConfigValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e OpenTelemetryConfigValidationError) ErrorName() string {
	return "OpenTelemetryConfigValidationError"
}

// Error satisfies the builtin error interface
func (e OpenTelemetryConfigValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sOpenTelemetryConfig.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = OpenTelemetryConfigValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = OpenTelemetryConfigValidationError{}
