//go:build !disable_pgv
// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: envoy/type/matcher/v3/filter_state.proto

package matcherv3

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"sort"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
	_ = sort.Sort
)

// Validate checks the field values on FilterStateMatcher with the rules
// defined in the proto definition for this message. If any rules are
// violated, the first error encountered is returned, or nil if there are no violations.
func (m *FilterStateMatcher) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on FilterStateMatcher with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// FilterStateMatcherMultiError, or nil if none found.
func (m *FilterStateMatcher) ValidateAll() error {
	return m.validate(true)
}

func (m *FilterStateMatcher) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if utf8.RuneCountInString(m.GetKey()) < 1 {
		err := FilterStateMatcherValidationError{
			field:  "Key",
			reason: "value length must be at least 1 runes",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	oneofMatcherPresent := false
	switch v := m.Matcher.(type) {
	case *FilterStateMatcher_StringMatch:
		if v == nil {
			err := FilterStateMatcherValidationError{
				field:  "Matcher",
				reason: "oneof value cannot be a typed-nil",
			}
			if !all {
				return err
			}
			errors = append(errors, err)
		}
		oneofMatcherPresent = true

		if all {
			switch v := interface{}(m.GetStringMatch()).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, FilterStateMatcherValidationError{
						field:  "StringMatch",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, FilterStateMatcherValidationError{
						field:  "StringMatch",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(m.GetStringMatch()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return FilterStateMatcherValidationError{
					field:  "StringMatch",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	case *FilterStateMatcher_AddressMatch:
		if v == nil {
			err := FilterStateMatcherValidationError{
				field:  "Matcher",
				reason: "oneof value cannot be a typed-nil",
			}
			if !all {
				return err
			}
			errors = append(errors, err)
		}
		oneofMatcherPresent = true

		if all {
			switch v := interface{}(m.GetAddressMatch()).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, FilterStateMatcherValidationError{
						field:  "AddressMatch",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, FilterStateMatcherValidationError{
						field:  "AddressMatch",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(m.GetAddressMatch()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return FilterStateMatcherValidationError{
					field:  "AddressMatch",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	default:
		_ = v // ensures v is used
	}
	if !oneofMatcherPresent {
		err := FilterStateMatcherValidationError{
			field:  "Matcher",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if len(errors) > 0 {
		return FilterStateMatcherMultiError(errors)
	}

	return nil
}

// FilterStateMatcherMultiError is an error wrapping multiple validation errors
// returned by FilterStateMatcher.ValidateAll() if the designated constraints
// aren't met.
type FilterStateMatcherMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m FilterStateMatcherMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m FilterStateMatcherMultiError) AllErrors() []error { return m }

// FilterStateMatcherValidationError is the validation error returned by
// FilterStateMatcher.Validate if the designated constraints aren't met.
type FilterStateMatcherValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e FilterStateMatcherValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e FilterStateMatcherValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e FilterStateMatcherValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e FilterStateMatcherValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e FilterStateMatcherValidationError) ErrorName() string {
	return "FilterStateMatcherValidationError"
}

// Error satisfies the builtin error interface
func (e FilterStateMatcherValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sFilterStateMatcher.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = FilterStateMatcherValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = FilterStateMatcherValidationError{}
