/*
Pulp 3 API

Fetch, Upload, Organize, and Distribute Software Packages

API version: v3
Contact: pulp-list@redhat.com
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pulpclient

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"strings"
	"reflect"
)


// ApiRolesAPIService ApiRolesAPI service
type ApiRolesAPIService service

type ApiRolesAPIApiV1RolesGetRequest struct {
	ctx context.Context
	ApiService *ApiRolesAPIService
	ansibleRoleHref string
	limit *int32
	offset *int32
	fields *[]string
	excludeFields *[]string
}

// Number of results to return per page.
func (r ApiRolesAPIApiV1RolesGetRequest) Limit(limit int32) ApiRolesAPIApiV1RolesGetRequest {
	r.limit = &limit
	return r
}

// The initial index from which to return the results.
func (r ApiRolesAPIApiV1RolesGetRequest) Offset(offset int32) ApiRolesAPIApiV1RolesGetRequest {
	r.offset = &offset
	return r
}

// A list of fields to include in the response.
func (r ApiRolesAPIApiV1RolesGetRequest) Fields(fields []string) ApiRolesAPIApiV1RolesGetRequest {
	r.fields = &fields
	return r
}

// A list of fields to exclude from the response.
func (r ApiRolesAPIApiV1RolesGetRequest) ExcludeFields(excludeFields []string) ApiRolesAPIApiV1RolesGetRequest {
	r.excludeFields = &excludeFields
	return r
}

func (r ApiRolesAPIApiV1RolesGetRequest) Execute() (*PaginatedGalaxyRoleResponseList, *http.Response, error) {
	return r.ApiService.ApiV1RolesGetExecute(r)
}

/*
ApiV1RolesGet Method for ApiV1RolesGet

APIView for Roles.

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param ansibleRoleHref
 @return ApiRolesAPIApiV1RolesGetRequest
*/
func (a *ApiRolesAPIService) ApiV1RolesGet(ctx context.Context, ansibleRoleHref string) ApiRolesAPIApiV1RolesGetRequest {
	return ApiRolesAPIApiV1RolesGetRequest{
		ApiService: a,
		ctx: ctx,
		ansibleRoleHref: ansibleRoleHref,
	}
}

// Execute executes the request
//  @return PaginatedGalaxyRoleResponseList
func (a *ApiRolesAPIService) ApiV1RolesGetExecute(r ApiRolesAPIApiV1RolesGetRequest) (*PaginatedGalaxyRoleResponseList, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *PaginatedGalaxyRoleResponseList
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ApiRolesAPIService.ApiV1RolesGet")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "{ansible_role_href}api/v1/roles/"
	localVarPath = strings.Replace(localVarPath, "{"+"ansible_role_href"+"}", parameterValueToString(r.ansibleRoleHref, "ansibleRoleHref"), -1)  // NOTE: paths aren't escaped because Pulp uses hrefs as path parameters

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.limit != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "limit", r.limit, "")
	}
	if r.offset != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "offset", r.offset, "")
	}
	if r.fields != nil {
		t := *r.fields
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "fields", s.Index(i), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "fields", t, "multi")
		}
	}
	if r.excludeFields != nil {
		t := *r.excludeFields
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "exclude_fields", s.Index(i), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "exclude_fields", t, "multi")
		}
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
