/*
Pulp 3 API

Fetch, Upload, Organize, and Distribute Software Packages

API version: v3
Contact: pulp-list@redhat.com
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pulpclient

import (
	"encoding/json"
)

// checks if the CertguardRHSMCertGuard type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CertguardRHSMCertGuard{}

// CertguardRHSMCertGuard RHSM Content Guard Serializer.
type CertguardRHSMCertGuard struct {
	// The unique name.
	Name string `json:"name"`
	// An optional description.
	Description NullableString `json:"description,omitempty"`
	// A Certificate Authority (CA) certificate (or a bundle thereof) used to verify client-certificate authenticity.
	CaCertificate string `json:"ca_certificate"`
	AdditionalProperties map[string]interface{}
}

type _CertguardRHSMCertGuard CertguardRHSMCertGuard

// NewCertguardRHSMCertGuard instantiates a new CertguardRHSMCertGuard object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCertguardRHSMCertGuard(name string, caCertificate string) *CertguardRHSMCertGuard {
	this := CertguardRHSMCertGuard{}
	this.Name = name
	this.CaCertificate = caCertificate
	return &this
}

// NewCertguardRHSMCertGuardWithDefaults instantiates a new CertguardRHSMCertGuard object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCertguardRHSMCertGuardWithDefaults() *CertguardRHSMCertGuard {
	this := CertguardRHSMCertGuard{}
	return &this
}

// GetName returns the Name field value
func (o *CertguardRHSMCertGuard) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *CertguardRHSMCertGuard) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *CertguardRHSMCertGuard) SetName(v string) {
	o.Name = v
}

// GetDescription returns the Description field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *CertguardRHSMCertGuard) GetDescription() string {
	if o == nil || IsNil(o.Description.Get()) {
		var ret string
		return ret
	}
	return *o.Description.Get()
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CertguardRHSMCertGuard) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Description.Get(), o.Description.IsSet()
}

// HasDescription returns a boolean if a field has been set.
func (o *CertguardRHSMCertGuard) HasDescription() bool {
	if o != nil && o.Description.IsSet() {
		return true
	}

	return false
}

// SetDescription gets a reference to the given NullableString and assigns it to the Description field.
func (o *CertguardRHSMCertGuard) SetDescription(v string) {
	o.Description.Set(&v)
}
// SetDescriptionNil sets the value for Description to be an explicit nil
func (o *CertguardRHSMCertGuard) SetDescriptionNil() {
	o.Description.Set(nil)
}

// UnsetDescription ensures that no value is present for Description, not even an explicit nil
func (o *CertguardRHSMCertGuard) UnsetDescription() {
	o.Description.Unset()
}

// GetCaCertificate returns the CaCertificate field value
func (o *CertguardRHSMCertGuard) GetCaCertificate() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CaCertificate
}

// GetCaCertificateOk returns a tuple with the CaCertificate field value
// and a boolean to check if the value has been set.
func (o *CertguardRHSMCertGuard) GetCaCertificateOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CaCertificate, true
}

// SetCaCertificate sets field value
func (o *CertguardRHSMCertGuard) SetCaCertificate(v string) {
	o.CaCertificate = v
}

func (o CertguardRHSMCertGuard) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CertguardRHSMCertGuard) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	if o.Description.IsSet() {
		toSerialize["description"] = o.Description.Get()
	}
	toSerialize["ca_certificate"] = o.CaCertificate

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return toSerialize, nil
}

func (o *CertguardRHSMCertGuard) UnmarshalJSON(bytes []byte) (err error) {
	varCertguardRHSMCertGuard := _CertguardRHSMCertGuard{}

	if err = json.Unmarshal(bytes, &varCertguardRHSMCertGuard); err == nil {
		*o = CertguardRHSMCertGuard(varCertguardRHSMCertGuard)
	}

	additionalProperties := make(map[string]interface{})

	if err = json.Unmarshal(bytes, &additionalProperties); err == nil {
		delete(additionalProperties, "name")
		delete(additionalProperties, "description")
		delete(additionalProperties, "ca_certificate")
		o.AdditionalProperties = additionalProperties
	}

	return err
}

type NullableCertguardRHSMCertGuard struct {
	value *CertguardRHSMCertGuard
	isSet bool
}

func (v NullableCertguardRHSMCertGuard) Get() *CertguardRHSMCertGuard {
	return v.value
}

func (v *NullableCertguardRHSMCertGuard) Set(val *CertguardRHSMCertGuard) {
	v.value = val
	v.isSet = true
}

func (v NullableCertguardRHSMCertGuard) IsSet() bool {
	return v.isSet
}

func (v *NullableCertguardRHSMCertGuard) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCertguardRHSMCertGuard(val *CertguardRHSMCertGuard) *NullableCertguardRHSMCertGuard {
	return &NullableCertguardRHSMCertGuard{value: val, isSet: true}
}

func (v NullableCertguardRHSMCertGuard) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCertguardRHSMCertGuard) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


